﻿local bossNameEN = "Azul Searbone"
local bossNameFR = "Azul Flambos"
local bossNameDE = "Azul Sengknochen"
local bossNameRUS = "Азул Костежог"

local buffNameEN = "Molten Rejuvenation"
local buffNameFR = "Rajeunissement en fusion"
local buffNameDE = "Geschmolzene Verjüngung"
local buffNameRUS = "Расплавленное обновление"

local bossName = ""
local buffName = ""

local language = Inspect.System.Language()
local AddonData = Inspect.Addon.Detail("azulfail")
local inCombat = false
local buffTimer = 0
local healed = false

local function onLoadEnd(id)
	if id ~= "azulfail" then return end
	
	if string.find(language, "English") then
		bossName = bossNameEN
		buffName = buffNameEN
	elseif string.find(language, "French") then
		bossName = bossNameFR
		buffName = buffNameFR
	elseif string.find(language, "German") then
		bossName = bossNameDE
		buffName = buffNameDE
	elseif string.find(language, "Russian") then
		bossName = bossNameRUS
		buffName = buffNameRUS
	else
		bossName = bossNameEN
		buffName = buffNameEN
	end
	
	print(AddonData.toc.Version .. " Loaded.")
end

local function onCombatEnter()
	inCombat = true
end

local function onCombatLeave()
	inCombat = false
end

local function onBuffAdd(unit, buffList)
	if inCombat then
		if unit then
			for buffID, bool in pairs(buffList) do
				local unitDetails = Inspect.Unit.Detail(unit)
				local buffDetails = Inspect.Buff.Detail(unit, buffID)	

				if unitDetails and buffDetails then
					if string.find(buffDetails.name, buffName) and string.find(unitDetails.name, bossName) then
						print(unitDetails.name .. " add " .. buffName)
						buffTimer = Inspect.Time.Real() + buffDetails.remaining
					end
				end
			end
		end
	end
end

local function onDamage(info)
	if inCombat then
		if buffTimer ~= 0 and healed == true then
			if string.find(info.targetName, bossName) then
				local me = Inspect.Unit.Detail("player")
				if me and info.caster == me.id and info.type and info.damage > 0 then
					print(info.casterName .. " hit " .. bossName .. " while " .. buffName .. " was up with " 
					.. info.abilityName .. " for " .. info.damage .. " " .. info.type .. " damage")
				end
				
				for x = 1, 20 do
					local unit = Inspect.Unit.Detail(string.format("group%02d", x))
					if unit and info.caster == unit.id and info.type and info.damage > 0 then
						print(info.casterName .. " hit " .. bossName .. " while " .. buffName .. " was up with " 
						.. info.abilityName .. " for " .. info.damage .. " " .. info.type .. " damage")
					end
				end
				
				healed = false
			end
		end
	end
end

local function onHeal(info)
	if inCombat then
		if buffTimer ~= 0 then
			if string.find(info.targetName, bossName) then
				healed = true
			end
		end
	end
end

local function onUpdate()
	if buffTimer > 0 then
		if Inspect.Time.Real() > buffTimer then
			print(bossName .. " remove " .. buffName)
			buffTimer = 0
		end
	end
end

table.insert(Event.Addon.Load.End, 
	{onLoadEnd, "azulfail", "Azul Fail loaded"})
table.insert(Event.System.Secure.Enter, 
	{onCombatEnter, "azulfail", "Combat entered"})
table.insert(Event.System.Secure.Leave, 
	{onCombatLeave, "azulfail", "Combat left"})
table.insert(Event.Buff.Add, 
	{onBuffAdd, "azulfail", "Buff Add"})
table.insert(Event.Combat.Damage, 
	{onDamage, "azulfail", "Combat damage"})
table.insert(Event.Combat.Heal, 
	{onHeal, "azulfail", "Combat heal"})
table.insert(Event.System.Update.Begin, 
	{onUpdate, "azulfail", "Update begin"})